洛谷P1314 [NOIP2011 提高组] 聪明的质监员 题解
题目链接:P1314 [NOIP2011 提高组] 聪明的质监员
题意:
小T
是一名质量监督员,最近负责检验一批矿产的质量。这批矿产共有 $n$ 个矿石,从 $1$ 到 $n$ 逐一编号,每个矿石都有自己的重量 $w_i$ 以及价值 $v_i$ 。检验矿产的流程是:1 、给定 $m$ 个区间 $[l_i,r_i]$;
2 、选出一个参数 $W$;
3 、对于一个区间 $[l_i,r_i]$,计算矿石在这个区间上的检验值 $y_i$:
其中 $j$ 为矿石编号。
这批矿产的检验结果 $y$ 为各个区间的检验值之和。即:$\sum\limits_{i=1}^m y_i$
若这批矿产的检验结果与所给标准值 $s$ 相差太多,就需要再去检验另一批矿产。
小T
不想费时间去检验另一批矿产,所以他想通过调整参数 $W$ 的值,让检验结果尽可能的靠近标准值 $s$,即使得 $|s-y|$ 最小。请你帮忙求出这个最小值。对于 $100\%$ 的数据,有 $1 ≤n ,m≤200,000$,$0 < w_i,v_i≤10^6$,$0 < s≤10^{12}$,$1 ≤l_i ≤r_i ≤n$ 。
注意到其实我们就是要算这个式子
$\sum_{j=l_i}^{r_i}[w_j \ge W]$ 是可以前缀和优化的
但是显然我们要知道 $W$ 才能计算这个柿子
考虑二分一个 $W \in [0,w_{\max}]$
对于绝对值的二分,我们直接拆掉绝对值
- 当 $s-y<0$ 时, $y$ 减小, $W$ 增大。
当 $s-y>0$ 时, $y$ 增大, $W$ 减小。
当 $s-y=0$ 时 ,直接退出即可。
答案只要在二分的过程中卑微的记录一下就好了
时间复杂度 $O(n \log W)$
代码:
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <iomanip>
using namespace std;
#define int long long
#define INF 0x3f3f3f3f3f3f3f3f
#define N (int)(2e5+15)
int n,m,s,l,r,mid;
int w[N],v[N],le[N],ri[N],res=INF,p[N],q[N];
signed main()
{
ios::sync_with_stdio(0);
cin.tie(0);cout.tie(0);
// freopen("check.in","r",stdin);
// freopen("check.out","w",stdout);
cin >> n >> m >> s;
for(int i=1; i<=n; i++)
{
cin >> w[i] >> v[i];
r=max(r,w[i]);
}
for(int i=1; i<=m; i++)
cin >> le[i] >> ri[i];
while(l<r)
{
int mid=(l+r+1)>>1;
for(int i=1; i<=n; i++)
{
if(w[i]>mid)
q[i]=q[i-1]+1,p[i]=p[i-1]+v[i];
else
q[i]=q[i-1],p[i]=p[i-1];
}
int x=0;
for(int i=1; i<=m; i++)
x+=(q[ri[i]]-q[le[i]-1])*(p[ri[i]]-p[le[i]-1]);
int t=s-x;
if(t<0)l=mid;
else if(!t)return cout << 0,0;
else r=mid-1;
res=min(res,abs(t));
}
cout << res << '\n';
return 0;
}